protected/controllers/FileController.php
<?php

class FileController extends Controller
{
	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow',  // allow all users to perform 'index' and 'view' actions
				'actions'=>array('index','view', 'create', 'update', 'delete', 'history', 'copy', 'translationHistory'),
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$model = $this->loadModel($id);
		$model->fetchLanguagesList();

		if (Yii::app()->request->getPost('translations') !== null || Yii::app()->request->getPost('translationsToRemove') !== null) {
			$translationData = Yii::app()->request->getPost('translations', array());
			$translationsToRemove = Yii::app()->request->getPost('translationsToRemove', array());

			if ($model->saveTranslations($translationData) === true) {
				$criteria = new CDbCriteria();
				$criteria->addInCondition('id', $translationsToRemove);

				$translationsToRemove = Translation::model()->findAll($criteria);

				foreach ($translationsToRemove as $translationToRemove) {
					$translationToRemove->delete();
				}

				$criteria = new CDbCriteria();
				$criteria->compare('system_version', $model->system_version);

				// if there are any translation history items added then the version should be increased.
				// This check is conducted to avoid gaps in system versions
				if (TranslationHistory::model()->count($criteria)) {
					$model->increaseVersion();
				}

				Yii::app()->user->setFlash('success', Yii::t('main', 'Saved'));

				// overwrite the translation data because needs translation can be missed in POST data if
				// it is turned off and then the button is active, since abscense of needs translation
				// is considered as needs translation
				$translationData = $model->getTranslationsData();
			} else {
				Yii::app()->user->setFlash('danger', Yii::t('main', reset($model->getErrors())[0]));
			}
		} else {
			$translationData = $model->getTranslationsData();
		}

		$this->render('view',array(
			'model'=>$model,
			'translationData' => $translationData,
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model = new File();
		if (Yii::app()->request->getQuery('project_id') !== null) {
			$model->project_id = Yii::app()->request->getQuery('project_id');

			if (Yii::app()->request->getPost('File') !== null) {
				$model->attributes = Yii::app()->request->getPost('File');
				$model->languagesList = array_keys(Yii::app()->request->getPost('Language', array()));
				if ($model->save()) {
					$this->redirect(array('file/' . $model->id . '/view'));
				}
			}

			$languages = Language::model()->findAll();

			$this->render('create',array(
				'model'=>$model,
				'languages' => $languages,
			));
		} else {
			$this->redirect(array('project/index'));
		}
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model = $this->loadModel($id);

		$model->fetchLanguagesList();

		if (Yii::app()->request->getPost('File') !== null) {
			$model->attributes = Yii::app()->request->getPost('File');
			$model->languagesList = array_keys(Yii::app()->request->getPost('Language', array()));

			if($model->save()) {
				$this->redirect(array('file/' . $model->id . '/view'));
			}
		}

		$languages = Language::model()->findAll();

		$this->render('update',array(
			'model'=>$model,
			'languages' => $languages,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$model = $this->loadModel($id);
		$model->delete();

		$this->redirect(array('project/' . $model->project_id . '/view'));
	}

	public function actionIndex()
	{
		$this->redirect(array('project/index'));
	}

	/**
	 * Shows difference between versions of a file.
	 */
	public function actionHistory($id)
	{
		$model = $this->loadModel($id);

		$criteria = new CDbCriteria();
		$criteria->select = 'DISTINCT system_version, version, created_date';
		$criteria->compare('file_id', $model->id);
		$criteria->order = 'created_date DESC';
		$translationsHistoryItems = TranslationHistory::model()->findAll($criteria);

		$versions = new stdClass();

		foreach ($translationsHistoryItems as $translationsHistoryItem) {
			$versions->{$translationsHistoryItem->system_version} = sprintf('v. %s#%05d (%s)', $translationsHistoryItem->version, $translationsHistoryItem->system_version, Yii::app()->dateTimeFormatter->toFormattedDateTime($translationsHistoryItem->created_date));
		}

		$versions = (array)$versions;

		if (Yii::app()->request->getQuery('from_version') !== null && Yii::app()->request->getQuery('to_version') !== null) {
			$diffs = $model->getDiff(Yii::app()->request->getQuery('from_version'), Yii::app()->request->getQuery('to_version'), (Yii::app()->request->getQuery('hide_unchanged_rows', '0') == '1'));

			$model->fetchLanguagesList();

			$this->render('diff-viewer',array(
				'model' => $model,
				'versions' => $versions,
				'translationData' => $diffs,
				'from_version' => Yii::app()->request->getQuery('from_version'),
				'to_version' => Yii::app()->request->getQuery('to_version'),
			));
		} else {
			$this->render('diff-viewer',array(
				'model' => $model,
				'versions' => $versions,
			));
		}
	}

	/**
	 * Copy an existing file into a new one
	 */
	public function actionCopy($id)
	{
		$model = $this->loadModel($id);

		$model->fetchLanguagesList();

		$criteria = new CDbCriteria();
		$criteria->select = 'DISTINCT system_version, version, created_date';
		$criteria->compare('file_id', $model->id);
		$criteria->order = 'created_date DESC';
		$translationsHistoryItems = TranslationHistory::model()->findAll($criteria);

		$versions = new stdClass();

		foreach ($translationsHistoryItems as $translationsHistoryItem) {
			$versions->{$translationsHistoryItem->system_version} = sprintf('v. %s#%05d (%s)', $translationsHistoryItem->version, $translationsHistoryItem->system_version, Yii::app()->dateTimeFormatter->toFormattedDateTime($translationsHistoryItem->created_date));
		}

		$versions = (array)$versions;

		if (Yii::app()->request->getQuery('version') !== null) {
			$model->fetchLanguagesList();

			$translationData = $model->getVersionTranslations(Yii::app()->request->getQuery('version'));

			$newModel = new File();
			$newModel->project_id = $model->project_id;
			$newModel->languagesList = $model->languagesList;
			$newModel->name = $model->name . ' - ' . Yii::t('main', 'Copy');

			if (Yii::app()->request->getPost('File') !== null) {
				if (Yii::app()->request->getPost('File') !== null) {
					$newModel->attributes = Yii::app()->request->getPost('File');
					if ($newModel->save() && $newModel->saveTranslations($translationData)) {
						Yii::app()->user->setFlash('success', Yii::t('main', 'Saved'));
						$this->redirect(array('file/' . $newModel->id . '/view'));
					} else {
						Yii::app()->user->setFlash('danger', Yii::t('main', 'An error coccured. Please try again later'));
					}
				}
			}

			$this->render('copy',array(
				'model' => $model,
				'newModel' => $newModel,
				'versions' => $versions,
				'translationData' => $translationData,
				'version' => Yii::app()->request->getQuery('version'),
			));
		} else {
			$this->render('copy',array(
				'model' => $model,
				'versions' => $versions,
			));
		}
	}

	public function actionTranslationHistory($id, $param)
	{
		$model = $this->loadModel($id);
		$model->fetchLanguagesList();

		$translationId = $param;

		if (Yii::app()->request->getQuery('language')) {
			$criteria = new CDbCriteria();
			$criteria->compare('translation_id', $translationId);
			$criteria->compare('file_id', $id);
			$criteria->compare('language_id', Yii::app()->request->getQuery('language'));
			$translationsHistory = TranslationHistory::model()->findAll($criteria);
		} else {
			$translationsHistory = array();
		}


		$this->render('translation-history',array(
			'model' => $model,
			'translationsHistory' => $translationsHistory,
			'language' => Yii::app()->request->getQuery('language')
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return File the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$criteria = new CDbCriteria();
		$criteria->together = true;
		$criteria->with = array('project', 'languages', 'fileToLanguages');
		$criteria->compare('project.company_id', Yii::app()->user->company->id);

		$model=File::model()->findByPk($id, $criteria);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}
}

protected/controllers/LanguageController.php
<?php

class LanguageController extends Controller
{
	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			array('allow',  // allow all users to perform 'index' and 'view' actions
				'actions'=>array('index', 'create', 'update', 'delete'),
				'users'=>array('@'),
			),
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$model=new Language('search');
		$model->unsetAttributes();  // clear any default values
		if (Yii::app()->request->getQuery('Language') !== null) {
			$model->attributes = Yii::app()->request->getQuery('Language');
		}

		$this->render('index',array(
			'model'=>$model,
		));
	}

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model = new Language();

		if (Yii::app()->request->getPost('Language') !== null) {
			$model->attributes = Yii::app()->request->getPost('Language');
			if ($model->save()) {
				if (Yii::app()->session['referer_url']) {
					$url = Yii::app()->session['referer_url'];
					unset(Yii::app()->session['referer_url']);
					$this->redirect($url);
				} else {
					$this->redirect(array('index'));
				}
			}
		} else {
			// remember referer to redirect back
			// it is done because we came to language creation from adding new file and
			// for comfort we should redirect back
			Yii::app()->session['referer_url'] = Yii::app()->request->urlReferrer;
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model = $this->loadModel($id);

		if (Yii::app()->request->getPost('Language') !== null) {
			$model->attributes = Yii::app()->request->getPost('Language');
			if ($model->save()) {
				$this->redirect(array('index'));
			}
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		$this->loadModel($id)->delete();
		$this->redirect(array('index'));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer $id the ID of the model to be loaded
	 * @return Language the loaded model
	 * @throws CHttpException
	 */
	public function loadModel($id)
	{
		$model=Language::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

}

protected/views/file/_form.php
<div class="row">
    <div class="col-md-12">
        <?php $form = $this->beginWidget('bootstrap.widgets.TbActiveForm'); ?>
            <fieldset>
                <div class="row">
                    <div class="col-md-5 col-md-offset-1">
                        <?php
                            echo $form->textFieldControlGroup($model, 'name');
                            echo $form->textareaControlGroup($model, 'comment');
                            echo $form->textFieldControlGroup($model, 'version', array(
                                'append' => '#' . Yii::app()->utils->formatSystemVersion($model->system_version),
                                'help' => Yii::t('main', 'The number at the end is a value that is automatically increased each time the file translations are saved. You can use it to avoid changing the version manually after each change.'),
                            ));
                            echo $form->checkboxControlGroup($model, 'key_column', array(
                                'help' => Yii::t('main', 'If you have custom keys for your translations you can have a separate column for them'),
                            ));
                        ?>
                    </div>

                    <div class="col-md-4">
                        <legend>Languages</legend>
                        <?php
                            foreach ($languages as $language) {
                                echo TbHtml::checkboxControlGroup('Language[' . $language->id . ']', in_array($language->id, $model->languagesList), array(
                                    'label' => $language->name . ' (' . $language->english_name . ')',
                                ));
                            }
                            if ($model->hasErrors('languagesList')) {
                                echo CHtml::tag('div', array('class' => 'has-error'),
                                    CHtml::tag('span', array('class' => 'help-block'), $model->getError('languagesList'))
                                );
                            }
                        ?>
                        <?php echo CHtml::link(Yii::t('main', 'Add new language'), array('language/create')); ?>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-5 col-md-offset-1">
                        <?php echo TbHtml::formActions(array(
                            TbHtml::submitButton($model->isNewRecord ? Yii::t('main', 'Create') : Yii::t('main', 'Save'), array('color' => TbHtml::BUTTON_COLOR_PRIMARY)),
                        )); ?>
                    </div>
                </div>
            </fieldset>
        <?php $this->endWidget(); ?>
    </div>
</div><!-- form -->

protected/views/file/copy.php
<?php
    $this->pageTitle = $model->project->name . ' > ' . $model->name;

    $this->breadcrumbs=array(
        Yii::t('main', 'Projects')=>array('project/index'),
        $model->project->name=>array('project/' . $model->project->id . '/view'),
        $model->name=>array('file/' . $model->id . '/view'),
        Yii::t('main', 'Copy file'),
    );

    $fromVersions = new stdClass();
    $fromVersions->{$model->system_version} = Yii::t('main', 'Current');

    echo TbHtml::pageHeader(Yii::t('main', 'Copy file'), $model->name);

    echo TbHtml::beginFormTb('', Yii::app()->createAbsoluteUrl(Yii::app()->request->getPathInfo()), 'get');
        echo CHtml::openTag('div', array('class' => 'form-group'));
            echo CHtml::openTag('div', array('class' => 'row'));
                echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::label(Yii::t('main', 'Version to copy'), 'selector-version-from'));
            echo CHtml::closeTag('div');
            echo CHtml::openTag('div', array('class' => 'row'));
                echo CHtml::openTag('div', array('class' => 'col-md-4'));
                    echo TbHtml::dropDownList(
                        'version',
                        Yii::app()->request->getQuery('version'),
                        array_merge(
                            (array)$fromVersions,
                            $versions
                        ),
                        array(
                            'id' => 'selector-version-from',
                        )
                    );
                echo CHtml::closeTag('div');
                echo CHtml::openTag('div', array('class' => 'col-md-2'));
                    echo TbHtml::formActions(array(
                        TbHtml::submitButton(Yii::t('main', 'Select'), array('color' => TbHtml::BUTTON_COLOR_INFO, 'name' => '')),
                    ));
                echo CHtml::closeTag('div');
            echo CHtml::closeTag('div');
        echo CHtml::closeTag('div');
    echo TbHtml::endForm();

    if (isset($translationData)) { ?>

<form method="POST" autocomplete="off">
    <table class="table translation-table copy-translation-table">
        <thead>
            <tr>
                <?php
                    if ($model->key_column == '1') {
                        echo CHtml::tag('th', array(), Yii::t('main', 'Key'));
                    }
                    foreach ($model->languages as $language) {
                        echo CHtml::tag('th', array(), $language->english_name);
                    }
                ?>
            </tr>
        </thead>
        <tbody>
            <?php if (count($translationData)) {
                foreach ($translationData as $key => $translationDataItem) {
                    echo CHtml::openTag('tr', array('id' => 'translation-key-' . $key));
                        if ($model->key_column == '1') {
                            if (isset($translationDataItem['key'])) {
                                Yii::app()->translationTableGenerator->renderPreviewCell('key', $key, $translationDataItem['key']);
                            } else {
                                Yii::app()->translationTableGenerator->renderPreviewCell('key', $key, '');
                            }
                        }

                        foreach ($model->languages as $language) {
                            $translation = isset($translationDataItem[$language->id]) ? $translationDataItem[$language->id] : '';
                            Yii::app()->translationTableGenerator->renderPreviewCell($language->id, $key, $translation);
                        }
                    echo CHtml::closeTag('tr');
                }
            } else {
                echo CHtml::openTag('tr', array('class' => 'no-translations-row'));
                    echo CHtml::tag('td', array(
                        'colspan' => count($model->languages) + 1,
                        'class' => 'text-center',
                    ), Yii::t('main', 'No translations yet'));
                echo CHtml::closeTag('tr');
            } ?>
        </tbody>
    </table>
    <?php
        echo CHtml::openTag('div', array('class' => 'row'));
            echo CHtml::tag('div', array('class' => 'col-md-12'), CHtml::tag('h3', array(), Yii::t('main', 'The new file data:')));
        echo CHtml::closeTag('div');

        echo CHtml::openTag('div', array('class' => 'row'));
            echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::activeTextFieldControlGroup($newModel, 'name'));
            echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::activeTextFieldControlGroup($newModel, 'comment'));
            echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::activeTextFieldControlGroup($newModel, 'version'));
        echo CHtml::closeTag('div');
        echo CHtml::openTag('div', array('class' => 'row'));
            echo CHtml::tag(
                'div',
                array(
                    'class' => 'col-md-12 text-right-md'
                ),
                TbHtml::submitButton(Yii::t('main', 'Copy'), array('color' => TbHtml::BUTTON_COLOR_PRIMARY))
            );
        echo CHtml::closeTag('div');
    ?>
</form>
<?php } ?>

protected/views/file/create.php
<?php
	$this->breadcrumbs=array(
		Yii::t('main', 'Projects')=>array('project/index'),
		$model->project->name=>array('project/' . $model->project->id . '/view'),
		Yii::t('main', 'Create file'),
	);

	echo TbHtml::pageHeader($model->project->name, Yii::t('main', 'Create file'));

	$this->renderPartial('_form', array('model' => $model, 'languages' => $languages));

protected/views/file/diff-viewer.php
<?php
    $this->pageTitle = $model->project->name . ' > ' . $model->name;

    $this->breadcrumbs = array(
        Yii::t('main', 'Projects')=>array('project/index'),
        $model->project->name=>array('project/' . $model->project->id . '/view'),
        $model->name=>array('file/' . $model->id . '/view'),
        Yii::t('main', 'File history'),
    );

    $fromVersions = new stdClass();
    $fromVersions->{$model->system_version} = Yii::t('main', 'Current');

    echo TbHtml::pageHeader(Yii::t('main', 'File history'), $model->name);

    echo TbHtml::beginFormTb('', Yii::app()->createAbsoluteUrl(Yii::app()->request->getPathInfo()), 'get');
        echo CHtml::openTag('div', array('class' => 'form-group'));
            echo CHtml::openTag('div', array('class' => 'row'));
                echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::label(Yii::t('main', 'The later one'), 'selector-version-from'));
                echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::label(Yii::t('main', 'The earlier one'), 'selector-version-to'));
            echo CHtml::closeTag('div');
            echo CHtml::openTag('div', array('class' => 'row'));
                echo TbHtml::hiddenField('id', $model->id);
                echo CHtml::openTag('div', array('class' => 'col-md-4'));
                    echo TbHtml::dropDownList(
                        'from_version',
                        Yii::app()->request->getQuery('from_version'),
                        array_merge(
                            (array)$fromVersions,
                            $versions
                        ),
                        array(
                            'id' => 'selector-version-from',
                        )
                    );
                echo CHtml::closeTag('div');
                echo CHtml::openTag('div', array('class' => 'col-md-4'));
                    echo TbHtml::dropDownList(
                        'to_version',
                        Yii::app()->request->getQuery('to_version'),
                        $versions,
                        array(
                            'id' => 'selector-version-to',
                        )
                    );
                echo CHtml::closeTag('div');
                echo CHtml::openTag('div', array('class' => 'col-md-2'));
                    echo TbHtml::checkBoxControlGroup(
                        'hide_unchanged_rows',
                        (Yii::app()->request->getQuery('hide_unchanged_rows', '0') == '1'),
                        array(
                            'label' => Yii::t('main', 'Hide unchanged rows'),
                        )
                    );
                echo CHtml::closeTag('div');
                echo CHtml::openTag('div', array('class' => 'col-md-2'));
                    echo TbHtml::formActions(array(
                        TbHtml::submitButton(Yii::t('main', 'Compare'), array('color' => TbHtml::BUTTON_COLOR_INFO, 'name' => '')),
                    ));
                echo CHtml::closeTag('div');
            echo CHtml::closeTag('div');
        echo CHtml::closeTag('div');
    echo TbHtml::endForm();

    if (isset($translationData)) {

        echo TbHtml::openTag('table', array(
            'class' => 'table translation-table diff-translation-table'
        ));
            echo TbHtml::openTag('thead');
                echo TbHtml::openTag('tr');
                    if (Yii::app()->utils->translationDiffHasKey($translationData)) {
                        echo CHtml::tag('th', array(), Yii::t('main', 'Key'));
                    }
                    foreach ($model->languages as $language) {
                        echo CHtml::tag('th', array(), $language->english_name);
                    }
                echo TbHtml::closeTag('tr');
            echo TbHtml::closeTag('thead');
            echo TbHtml::openTag('tbody');
                if (count($translationData)) {
                    foreach ($translationData as $key => $translationDataItem) {
                        echo CHtml::openTag('tr', array('id' => 'translation-key-' . $key, 'data-id' => $key));

                            if (Yii::app()->utils->translationDiffHasKey($translationData)) {
                                if (is_array($translationDataItem['key'])) {
                                    Yii::app()->translationTableGenerator->renderDiffCell($model->id, $key, $translationDataItem['key']['oldValue'], $translationDataItem['key']['newValue'], $translationDataItem['key']['action']);
                                } else {
                                    Yii::app()->translationTableGenerator->renderDiffCell($model->id, $key, $translationDataItem['key']);
                                }
                            }

                            foreach ($model->languages as $language) {
                                $translation = isset($translationDataItem[$language->id]) ? $translationDataItem[$language->id] : '';
                                if (is_array($translation)) {
                                    Yii::app()->translationTableGenerator->renderDiffCell($model->id, $key, $translation['oldValue'], $translation['newValue'], $translation['action']);
                                } else {
                                    Yii::app()->translationTableGenerator->renderDiffCell($model->id, $key, $translation);
                                }
                            }
                        echo CHtml::closeTag('tr');
                    }
                } else {
                    echo CHtml::openTag('tr', array('class' => 'no-translations-row'));
                        echo CHtml::tag('td', array(
                            'colspan' => count($model->languages),
                            'class' => 'text-center',
                        ), Yii::t('main', 'There is no difference between thses versions'));
                    echo CHtml::closeTag('tr');
                }
            echo TbHtml::closeTag('tbody');
        echo TbHtml::closeTag('table');
    }

protected/views/file/translation-history.php
<?php
    $this->pageTitle = $model->project->name . ' > ' . $model->name;

    $this->breadcrumbs=array(
        Yii::t('main', 'Projects')=>array('project/index'),
        $model->project->name=>array('project/' . $model->project->id . '/view'),
        $model->name=>array('file/' . $model->id . '/view'),
        Yii::t('main', 'Translation history'),
    );

    echo TbHtml::pageHeader(Yii::t('main', 'Translation history'), $model->name);

    echo TbHtml::beginFormTb('', Yii::app()->createAbsoluteUrl(Yii::app()->request->getPathInfo()), 'get');
        echo CHtml::openTag('div', array('class' => 'form-group'));
            echo CHtml::openTag('div', array('class' => 'row'));
                echo CHtml::tag('div', array('class' => 'col-md-4'), TbHtml::label(Yii::t('main', 'Choose language'), 'language'));
            echo CHtml::closeTag('div');
            echo CHtml::openTag('div', array('class' => 'row'));
                echo CHtml::openTag('div', array('class' => 'col-md-4'));
                    echo TbHtml::dropDownList(
                        'language',
                        Yii::app()->request->getQuery('language'),
                        CHtml::listData($model->languages, 'id', 'english_name'),
                        array(
                            'id' => 'language',
                            'empty' => Yii::t('main', 'Select a language')
                        )
                    );
                echo CHtml::closeTag('div');
                echo CHtml::openTag('div', array('class' => 'col-md-2'));
                    echo TbHtml::formActions(array(
                        TbHtml::submitButton(Yii::t('main', 'Select'), array('color' => TbHtml::BUTTON_COLOR_SUCCESS, 'name' => '')),
                    ));
                echo CHtml::closeTag('div');
            echo CHtml::closeTag('div');
        echo CHtml::closeTag('div');
    echo TbHtml::endForm();

    if (isset($translationsHistory) && count($translationsHistory)) {
        echo CHtml::openTag('div', array('class' => 'translation-history-container'));
            foreach ($translationsHistory as $key => $translationsHistoryItem) {
                // if ($translationsHistoryItem->value_before != $translationsHistoryItem->value_after) {
                    echo CHtml::openTag('div', array('class' => 'translation-history-item'));
                        echo CHtml::openTag('div', array('class' => 'translation-history-data bg-primary col-md-12'));
                            echo CHtml::encode($translationsHistoryItem->value_after);
                            echo CHtml::openTag('div', array('class' => 'translation-history-info'));
                                echo sprintf('<b>%s</b> (v. %s#%05d)', Yii::app()->dateTimeFormatter->toFormattedDateTime($translationsHistoryItem->created_date), $translationsHistoryItem->version, $translationsHistoryItem->system_version);
                            echo CHtml::closeTag('div');
                        echo CHtml::closeTag('div');
                    echo CHtml::closeTag('div');
                // }
            }
        echo CHtml::closeTag('div');
    } else {
        echo CHtml::openTag('div', array('class' => 'row'));
            echo CHtml::openTag('div', array('class' => 'col-md-12'));
                if ($language === null || strlen($language) == 0) {
                    echo Yii::t('main', 'Please, select a language');
                } else {
                    echo Yii::t('main', 'Nothing happened to this translation');
                }
            echo CHtml::closeTag('div');
        echo CHtml::closeTag('div');
    }

protected/views/file/update.php
<?php
	$this->breadcrumbs=array(
		Yii::t('main', 'Projects')=>array('project/index'),
		$model->project->name=>array('project/' . $model->project->id . '/view'),
		$model->name=>array('file/' . $model->id . '/view'),
		Yii::t('main', 'Update file'),
	);

	echo TbHtml::pageHeader($model->project->name . '/' . $model->name, Yii::t('main', 'Update'));

	$this->renderPartial('_form', array('model' => $model, 'languages' => $languages));